using System;
using System.IO;
using System.Text;
using System.Security.Cryptography;

using System.Collections;

namespace ComUtil
{
	/// <remarks>
	/// <b>.NET ȣȭ Namespace    </b> :<br/>
	/// MD5 ؽ, RSA ȣȭ/ȣȭ  DESCryptoServiceProvider  ̿ ȣȭ/ȣȭ մϴ.<br/>
	/// <br/>
	/// </remarks>
	public class CryptoService
	{
		/// <summary>
		/// RSA ȣȭ , ѹ ȣȭǴ  ũ⸦ 
		/// </summary>
		static int rsa_EncChunkSize = 50;
		/// <summary>
		/// RSA ȣȭ , ѹ ȣȭǴ  ũ⸦ 
		/// </summary>
		static int rsa_DecChunkSize = 128;

		/// <summary>
		/// RSA ȣȭ մϴ.
		/// </summary>
		/// <param name="byteText">ȣȭų byte </param>
		/// <param name="szPubKey">RSA Ű</param>
		/// <returns>Base64 ڵ ȣȭ ڿ</returns>
		static public string EncryptRSA( byte [] byteText, string szPubKey )
		{
			RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
			rsa.FromXmlString( szPubKey );

			// 50 byte   ȣȭ մϴ.
			int nPos = 0;
			ArrayList arrChunk = new ArrayList();
			int nEncSize = 0;
			int nChunkSize = rsa_EncChunkSize;

			int nCount;

			int nLoopCount = 0;
			while ( true ) 
			{
				nCount = byteText.Length - nPos;

				if ( nCount <= 0 ) break;
				else if ( nCount < rsa_EncChunkSize ) nChunkSize = nCount;

				nLoopCount ++;

				Byte [] byteChunk = new byte [ nChunkSize ];

				Buffer.BlockCopy( byteText, nPos, byteChunk, 0, nChunkSize );

				byte [] byteEncrypted = rsa.Encrypt( byteChunk, false );
				nEncSize += byteEncrypted.Length;

				arrChunk.Add( byteEncrypted );
				nPos += rsa_EncChunkSize;
			}

			byte [] byteFulText = new byte [ nEncSize ];
			for ( int i = 0; i < arrChunk.Count; i ++ ) 
			{
				byte [] byteChunk = (byte [])arrChunk[i];
				Buffer.BlockCopy( byteChunk, 0, byteFulText, i * ( rsa_DecChunkSize ), byteChunk.Length );
			}

			// Base64 ڵմϴ.
			return Convert.ToBase64String( byteFulText );
		}

		/// <summary>
		/// ڿ ȣȭŵϴ.
		/// </summary>
		/// <param name="strEncText">ȣȭų ڿ( Base64 ڵ Ǿ  )</param>
		/// <param name="szPrvKey">RSA Ű</param>
		/// <returns>ȣȭ  </returns>
		static public byte [] DecryptRSA( string strEncText, string szPrvKey )
		{
			if ( strEncText == "" || szPrvKey == "" ) 
			{
				return null;
			}

			RSACryptoServiceProvider rsa = new RSACryptoServiceProvider();
			rsa.FromXmlString( szPrvKey );

			// 켱 byte[]  ȯմϴ.
			byte [] byteText = Convert.FromBase64String( strEncText );

			// 128 byte   ȣȭŵϴ.

			ArrayList arrChunk = new ArrayList();
			int nCount;
			int nPos = 0;
			int nChunkSize = rsa_DecChunkSize;
			int nDecSize = 0;
			while ( true ) 
			{
				nCount = byteText.Length - nPos;

				if ( nCount <= 0 ) break;
				else if ( nCount < rsa_DecChunkSize ) nChunkSize = nCount;

				Byte [] byteChunk = new byte [ nChunkSize ];

				Buffer.BlockCopy( byteText, nPos, byteChunk, 0, nChunkSize );

				byte [] byteDecrypted = rsa.Decrypt( byteChunk, false );
				nDecSize += byteDecrypted.Length;

				arrChunk.Add( byteDecrypted );
				nPos += rsa_DecChunkSize;
			}
			byte [] byteFullText = new byte [ nDecSize ];
			for ( int i = 0; i < arrChunk.Count; i ++ ) 
			{
				byte [] byteChunk = (byte [])arrChunk[i];
				Buffer.BlockCopy( byteChunk, 0, byteFullText, i * rsa_EncChunkSize, byteChunk.Length );
			}

			return byteFullText;
		}

		/// <summary>
		/// DESCryptoServiceProvider  ̿Ͽ ȣȭŵϴ.
		/// </summary>
		/// <param name="strText">ȣȭų ؽƮ</param>
		/// <param name="byteKey">Key byte </param>
		/// <param name="byteIV">IV byte </param>
		/// <returns>Base64 ڵ ȣȭ ڿ</returns>
		static public string EncryptString( string strText, byte[] byteKey, byte[] byteIV )
		{
			DESCryptoServiceProvider desType = new DESCryptoServiceProvider();
			
			MemoryStream memStream = new MemoryStream();
			CryptoStream iMemStream = new CryptoStream( memStream, desType.CreateEncryptor( byteKey, byteIV ), CryptoStreamMode.Write );
			byte [] byteArray = System.Text.Encoding.Default.GetBytes( strText );

			iMemStream.Write( byteArray, 0, byteArray.Length );
			iMemStream.Close();

			byte[] byteText = memStream.ToArray();
			memStream.Close();

			return Convert.ToBase64String( byteText );
		}
		

		/// <summary>
		/// DESCryptoServiceProvider  ̿Ͽ ȣȭŵϴ.
		/// </summary>
		/// <param name="strText">ȣȭ ڿ( Base64 ڵǾ  )</param>
		/// <param name="byteKey">Key byte </param>
		/// <param name="byteIV">IV byte </param>
		/// <returns>ȣȭ  </returns>
		static public string DecryptString( string strText, byte[] byteKey, byte[] byteIV )
		{
			// 켱 Base64 ڵ ŵϴ.
			byte [] byteArray = Convert.FromBase64String( strText );

			DESCryptoServiceProvider desType = new DESCryptoServiceProvider();
			
			MemoryStream memStream = new MemoryStream();
			CryptoStream iMemStream = new CryptoStream( memStream, desType.CreateDecryptor( byteKey, byteIV ), CryptoStreamMode.Write );

			iMemStream.Write( byteArray, 0, byteArray.Length );
			iMemStream.Close();

			byte[] byteText = memStream.ToArray();
			memStream.Close();

			return Encoding.Default.GetString( byteText, 0, byteText.Length );
		}

		/// <summary>
		/// ܹ ؽ ˰ MD5  ̿ؼ ؽƮ ȣȭ ŵϴ.
		/// </summary>
		/// <param name="strText">Hash  ؽƮ</param>
		/// <returns>Hash  ؽƮ</returns>
		static public string GetMD5HashText( string strText )
		{
			byte [] byteContents = Encoding.Default.GetBytes( strText );

			MD5 hash = new MD5CryptoServiceProvider();
			byte [] hashText = hash.ComputeHash( byteContents );

			return Convert.ToBase64String( hashText );
		}
	}
}
